Attribute VB_Name = "MRobot"
Option Explicit
Public Type Color
   r As Byte
   G As Byte
   B As Byte
   a As Byte
End Type
Public Type Ellipse
    Left      As Double
    Top       As Double
    Width     As Double
    Height    As Double
    'HorizontalAlignment As Long '= HorizontalAlignment.Left,
    'VerticalAlignment As Long '= VerticalAlignment.Top,
    FillColor As Long ' = new SolidColorBrush(_nextColor)
End Type
Public Type RoomPoint
    x As Long
    y As Long
End Type
Public Type Robot
    Element   As Ellipse
    Location  As RoomPoint
End Type

Public NullRobot As Robot

Public Type ListOfRobot
   Count As Long
   Arr() As Robot
End Type
Private Declare Sub GetMem4 Lib "msvbvm60" (ByVal pSrc As Long, ByRef pDst As Long)

Public Function ColorRGB(ByVal aR As Byte, ByVal aG As Byte, ByVal aB As Byte) As Color
    With ColorRGB:  .r = aR:  .G = aG:  .B = aB:  End With
End Function
Public Function ColorToLong(this As Color) As Long
    With this
        ColorToLong = RGB(.r, .G, .B)
    End With
End Function


Public Function New_Ellipse(ByVal w As Double, ByVal h As Double, c As Color) As Ellipse
    With New_Ellipse
        .Width = w
        .Height = h
        .FillColor = ColorToLong(c)
    End With
End Function

Public Function New_RoomPoint(ByVal aX As Long, ByVal aY As Long) As RoomPoint
    With New_RoomPoint
       .x = aX
       .y = aY
    End With
End Function
Public Function RoomPoint_ToString(this As RoomPoint) As String
    With this
        RoomPoint_ToString = "( x: " & CStr(.x) & " | y: " & CStr(.y) & " )"
    End With
End Function
Public Function New_Robot(loc As RoomPoint, el As Ellipse) As Robot
    With New_Robot
        .Element = el
        .Location = loc
    End With
End Function
Public Function DistanceTo(this As RoomPoint, other As RoomPoint) As Double
    With this
       DistanceTo = VBA.Math.Sqr(Square(other.x - .x) + Square(other.y - .y))
    End With
End Function
Public Function AngleTo(this As RoomPoint, other As RoomPoint) As Double
    With this
        AngleTo = Math.Atan2(other.y - .y, other.x - .x)
    End With
End Function
Public Function IsEqual(this As Robot, other As Robot) As Boolean
    'IsEqual = False
    With this
        If .Location.x = other.Location.x Then
            If .Location.y = other.Location.y Then
                IsEqual = True
            End If
        End If
    End With
End Function
Public Sub ListOfRobot_Add(this As ListOfRobot, r As Robot)
    With this
        If .Count = 0 Then
            ReDim .Arr(0 To 16 - 1)
        ElseIf .Count = UBound(.Arr) Then
            ReDim Preserve .Arr(0 To 2 * .Count - 1)
        End If
        .Arr(.Count) = r
        .Count = .Count + 1
    End With
End Sub
Public Sub ListOfRobot_Clear(this As ListOfRobot)
    With this
        Erase .Arr
        .Count = 0
    End With
End Sub

